Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_fromFile.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_fromFile.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_fromFile.cpp	(revision 88)
@@ -0,0 +1,133 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Generator.h"
+#include "Common/include/FromString.h"
+#include <fstream>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+  using namespace XMLUtils;
+
+#undef  FUNCTION
+#define FUNCTION "Generator::fromFile"
+  void Generator::fromFile (std::string filename)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    msg_printf(INFORMATION,_("Read file \"%s\"."),filename.c_str());
+
+    std::ifstream file (filename.c_str());
+
+    // Test the file open
+    if (!file)
+      throw ERRORMORPHEO(FUNCTION,toString(_("Error opening \"%s\" file.\n"),filename.c_str()));
+
+    XML_t * _xml = new FileXMLLight<char,ClassicReferenceCounter>(file);
+
+    // Test root node : Root name, must not a singleton, have none attribute
+    testNodeName   (_xml,"parameters");
+    testSingleton  (_xml,false);
+    testNoAttribute(_xml);
+
+    XMLLightVector<XML_t> vect = _xml->getNodes(); 
+
+//     std::cout << vect << std::endl;
+
+    for (uint32_t i=0; i<vect.size(); ++i)
+      {
+        XML_t * xml = vect[i];
+
+        std::string node_name = xml->getName();
+
+        //--------------------------------------
+        // Node : Parameter
+        //--------------------------------------
+        if (node_name == "parameter")
+          {
+            testSingleton  (xml,true);        
+            
+            // Take attributes of this tag
+            
+            attributes_t attributes = xml->getAttributes();
+            
+//          std::cout << "Node [" << name           << "]" << std::endl;
+//          std::cout << "  * nb attributes : " << xml->getAttributes().size()  << std::endl;
+            
+            attribute_t value_name        = getAttribute(xml,attributes,"name"   );
+            attribute_t value_default     = getAttribute(xml,attributes,"default");
+            attribute_t value_level       = (xml->containsAttribute("level"      ))?getAttribute(xml,attributes,"level"      ):"3";
+            attribute_t value_description = (xml->containsAttribute("description"))?getAttribute(xml,attributes,"description"):"";
+            
+            bool is_binary = not (xml->containsAttribute("min" ) or
+                                  xml->containsAttribute("max" ) or
+                                  xml->containsAttribute("step"));
+            
+            attribute_t value_min         = (not is_binary)?getAttribute(xml,attributes,"min" ):"0";
+            attribute_t value_max         = (not is_binary)?getAttribute(xml,attributes,"max" ):"1";
+            attribute_t value_step        = (not is_binary)?getAttribute(xml,attributes,"step"):"+ 1";
+            
+            testAttributesEmpty(xml,attributes);
+            
+            // Insert in array
+            Parameter_definition * param = new Parameter_definition(value_name       ,
+                                                                    value_min        ,
+                                                                    value_max        ,
+                                                                    value_step       ,
+                                                                    value_default    ,
+                                                                    value_level      ,
+                                                                    value_description);
+            
+            insert(param);
+          }
+        else
+        //--------------------------------------
+        // Node : Link
+        //--------------------------------------
+        if (node_name == "link")
+          {
+            testSingleton  (xml,true);        
+            
+            // Take attributes of this tag
+            
+            attributes_t attributes = xml->getAttributes();
+            
+//          std::cout << "Node [" << name           << "]" << std::endl;
+//          std::cout << "  * nb attributes : " << xml->getAttributes().size()  << std::endl;
+            
+            attribute_t value_name        = getAttribute(xml,attributes,"name");
+            attribute_t value_src         = getAttribute(xml,attributes,"src" );
+            attribute_t value_dest        = (xml->containsAttribute("dest"       ))?getAttribute(xml,attributes,"dest"       ):"";
+            attribute_t value_description = (xml->containsAttribute("description"))?getAttribute(xml,attributes,"description"):"";
+            
+            testAttributesEmpty(xml,attributes);
+            
+            // Insert in array
+            Link_definition * param = new Link_definition(value_name       ,
+                                                          value_src        ,
+                                                          value_dest       ,
+                                                          value_description);
+            
+            insert(param);
+          }
+        //--------------------------------------
+        // Node : Unknow
+        //--------------------------------------
+        else
+          throw ERRORMORPHEO(FUNCTION,toString(_("Syntax error, node \"%s\" is unknow.\n"),node_name.c_str()));
+      }
+         
+    delete _xml;
+
+    log_end(Configuration,FUNCTION);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_getLink.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_getLink.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_getLink.cpp	(revision 88)
@@ -0,0 +1,34 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Generator.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Generator::getLink"
+  Link_definition * Generator::getLink (std::string name)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::map<std::string, Link_definition *>::iterator it_link = _array_link->find(name);
+    
+    if (it_link == _array_link->end())
+      {
+        throw (ERRORMORPHEO(FUNCTION,toString(_("Link \"%s\" is unknow.\n"),name.c_str())));
+      }
+
+    log_end(Configuration,FUNCTION);
+
+    return it_link->second;
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_getParam.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_getParam.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_getParam.cpp	(revision 88)
@@ -0,0 +1,34 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Generator.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Generator::getParam"
+  Parameter_definition * Generator::getParam (std::string name)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::map<std::string, Parameter_definition *>::iterator it_param = _array_param->find(name);
+    
+    if (it_param == _array_param->end())
+      {
+        throw (ERRORMORPHEO(FUNCTION,toString(_("Parameter \"%s\" is unknow.\n"),name.c_str())));
+      }
+
+    log_end(Configuration,FUNCTION);
+
+    return it_param->second;
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_insert.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_insert.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_insert.cpp	(revision 88)
@@ -0,0 +1,36 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Generator.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Generator::insert"
+  void Generator::insert (Parameter_definition * param)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    (*_array_param)[param->_name] = param;
+
+    log_end(Configuration,FUNCTION);
+  };
+
+  void Generator::insert (Link_definition * link)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    (*_array_link)[link->_name] = link;
+
+    log_end(Configuration,FUNCTION);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_print.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_print.cpp	(revision 88)
@@ -0,0 +1,39 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Generator.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Generator::print"
+  std::string Generator::print (uint32_t depth)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::string _return = (toXML()).get_body(depth);
+
+    log_end(Configuration,FUNCTION);
+    return _return;
+  };
+  
+#undef  FUNCTION
+#define FUNCTION "Generator::operator<<"
+  std::ostream& operator<< (std::ostream& output,
+			    morpheo::behavioural::configuration::Generator & x)
+  {
+    log_begin(Configuration,FUNCTION);
+    output << x.print(0);
+    log_end(Configuration,FUNCTION);
+    return output;
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_test.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_test.cpp	(revision 88)
@@ -0,0 +1,68 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Generator.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Generator::test"
+  void Generator::test (std::string param, std::string x)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    std::map<std::string, Parameter_definition *>::iterator it_param = _array_param->find(param);
+    
+    if (it_param == _array_param->end())
+      {
+        throw (ERRORMORPHEO(FUNCTION,toString(_("Parameter \"%s\" is unknow.\n"),param.c_str())));
+      }
+    else
+      {
+        it_param->second->test(x);    
+      }
+
+    log_end(Configuration,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Generator::test"
+  void Generator::test (std::string link,
+                        std::string father_name,
+                        bool        father_is_src,
+                        bool        father_is_dest)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    // Link ?
+    std::map<std::string, Link_definition *>::iterator it_link = _array_link->find(link);
+    
+    if (it_link == _array_link->end())
+      {
+        throw (ERRORMORPHEO(FUNCTION,toString(_("Link \"%s\" is unknow.\n"),link.c_str())));
+      }
+
+    if ((father_is_src ) and
+        (father_name != it_link->second->_src ))
+      {
+        throw (ERRORMORPHEO(FUNCTION,toString(_("Link \"%s\", must be instance as source in component \"%s\", but find in component \"%s\".\n"),link.c_str(),it_link->second->_src.c_str(),father_name.c_str())));
+      }
+
+    if ((father_is_dest ) and
+        (father_name != it_link->second->_dest ))
+      {
+        throw (ERRORMORPHEO(FUNCTION,toString(_("Link \"%s\", must be instance as destination in component \"%s\", but find in component \"%s\".\n"),link.c_str(),it_link->second->_dest.c_str(),father_name.c_str())));
+      }
+
+    log_end(Configuration,FUNCTION);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_toFile.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_toFile.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_toFile.cpp	(revision 88)
@@ -0,0 +1,27 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Generator.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Generator::toFile"
+  void Generator::toFile (std::string dirname)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    (toXML()).generate_file(dirname);
+
+    log_end(Configuration,FUNCTION);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_toXML.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_toXML.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Generator_toXML.cpp	(revision 88)
@@ -0,0 +1,41 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Generator.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Generator::toXML"
+  XML Generator::toXML (void)
+  {
+    XML xml (basename(_filename.c_str()));
+    xml.filename_extension("");
+    
+    xml.balise_open("parameters");
+    for (std::map<std::string, Parameter_definition *>::iterator it = _array_param->begin();
+         it != _array_param->end();
+         ++it)
+      {
+        xml.insert_XML(it->second->toXML(),1);
+      }
+    for (std::map<std::string, Link_definition *>::iterator it = _array_link->begin();
+         it != _array_link->end();
+         ++it)
+      {
+        xml.insert_XML(it->second->toXML(),1);
+      }
+    xml.balise_close();
+
+    return xml;
+  }
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance.cpp	(revision 88)
@@ -0,0 +1,179 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+#include "Behavioural/include/Allocation.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+#undef  FUNCTION
+#define FUNCTION "Instance::Instance"
+  Instance::Instance  (std::string filename, 
+                       Generator * generator,
+                       behavioural::custom::custom_information_t (*get_custom_information) (void))
+  {
+    log_begin(Configuration,FUNCTION);
+
+    _name      = "";
+    _filename  = filename;
+
+    _list_parameters = new list_parameters_t;
+    _list_links      = new list_links_t;
+    _list_components = new list_components_t;
+
+    _generator = generator;
+    _param     = new Parameters;
+    _param->_get_custom_information = get_custom_information;
+
+    fromFile (filename);
+
+    log_end(Configuration,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Instance::~Instance"
+  Instance::~Instance () 
+  {
+    log_begin(Configuration,FUNCTION);
+
+    for (list_parameters_t::iterator it = _list_parameters->begin();
+         it != _list_parameters->end();
+         ++it)
+      delete it->second;
+    delete _list_parameters;
+
+    for (list_links_t::iterator it1 = _list_links->begin();
+         it1 != _list_links->end();
+         ++it1)
+      for (list_link_t::iterator it2 = it1->second.begin();
+           it2 != it1->second.end();
+           ++it2)
+        delete it2->second;
+    delete _list_links;
+    
+    for (list_components_t::iterator it1 = _list_components->begin();
+         it1 != _list_components->end();
+         ++it1)
+      for (list_instances_t::iterator it2 = it1->second.begin();
+           it2 != it1->second.end();
+           ++it2)
+        delete it2->second;
+    delete _list_components;
+
+    if (_param != NULL) // TEST A ENLEVER
+      {
+        DELETE2(_param->_link_dcache_port_with_load_store_unit  ,_param->_nb_load_store_unit,_param->_nb_cache_port[it1]);
+        DELETE1(_param->_link_icache_port_with_thread           ,_param->_nb_thread);
+        DELETE2(_param->_link_thread_and_functionnal_unit       ,_param->_nb_thread,_param->_nb_functionnal_unit);
+        DELETE1(_param->_link_load_store_unit_with_thread       ,_param->_nb_thread);
+        DELETE2(_param->_link_write_bloc_and_functionnal_unit   ,_param->_nb_write_bloc,_param->_nb_functionnal_unit);
+        DELETE2(_param->_link_write_bloc_and_load_store_unit    ,_param->_nb_write_bloc,_param->_nb_load_store_unit);
+        DELETE2(_param->_link_read_bloc_and_functionnal_unit    ,_param->_nb_read_bloc,_param->_nb_functionnal_unit);
+        DELETE2(_param->_link_read_bloc_and_load_store_unit     ,_param->_nb_read_bloc,_param->_nb_load_store_unit);
+        DELETE3(_param->_table_dispatch                         ,_param->_nb_ooo_engine,_param->_nb_inst_issue[it1],_param->_nb_read_bloc);
+        DELETE1(_param->_link_rename_bloc_with_front_end        ,_param->_nb_front_end);
+        DELETE1(_param->_link_decod_bloc_with_thread            ,_param->_nb_thread);
+        DELETE1(_param->_link_execute_unit_with_load_store_unit ,_param->_nb_load_store_unit);
+        DELETE1(_param->_link_execute_unit_with_functionnal_unit,_param->_nb_functionnal_unit);
+        DELETE1(_param->_link_write_unit_with_write_bloc        ,_param->_nb_write_bloc);
+        DELETE1(_param->_link_read_unit_with_read_bloc          ,_param->_nb_read_bloc);
+        DELETE1(_param->_link_rename_unit_with_rename_bloc      ,_param->_nb_rename_bloc);
+        DELETE1(_param->_link_decod_unit_with_decod_bloc        ,_param->_nb_decod_bloc);
+        DELETE1(_param->_link_context_with_thread               ,_param->_nb_thread);
+        DELETE1(_param->_read_unit_to_execution_unit_priority   ,_param->_nb_execute_loop);
+        DELETE1(_param->_execution_unit_to_write_unit_priority  ,_param->_nb_execute_loop);
+        DELETE1(_param->_nb_spr_port_write_by_bank              ,_param->_nb_execute_loop);
+        DELETE1(_param->_nb_spr_port_read_by_bank               ,_param->_nb_execute_loop);
+        DELETE1(_param->_nb_spr_bank                            ,_param->_nb_execute_loop);
+        DELETE1(_param->_nb_gpr_port_write_by_bank              ,_param->_nb_execute_loop);
+        DELETE1(_param->_nb_gpr_port_read_by_bank               ,_param->_nb_execute_loop);
+        DELETE1(_param->_nb_gpr_bank                            ,_param->_nb_execute_loop);
+        DELETE1(_param->_nb_write_unit                          ,_param->_nb_execute_loop);
+        DELETE1(_param->_nb_execute_unit                        ,_param->_nb_execute_loop);
+        DELETE1(_param->_nb_read_unit                           ,_param->_nb_execute_loop);
+        DELETE1(_param->_reexecute_load_balancing               ,_param->_nb_ooo_engine);
+        DELETE1(_param->_reexecute_priority                     ,_param->_nb_ooo_engine);
+        DELETE1(_param->_size_reexecute_queue                   ,_param->_nb_ooo_engine);
+        DELETE1(_param->_issue_load_balancing                   ,_param->_nb_ooo_engine);
+        DELETE1(_param->_issue_priority                         ,_param->_nb_ooo_engine);
+        DELETE1(_param->_nb_issue_queue_bank                    ,_param->_nb_ooo_engine);
+        DELETE1(_param->_size_issue_queue                       ,_param->_nb_ooo_engine);
+        DELETE1(_param->_commit_load_balancing                  ,_param->_nb_ooo_engine);
+        DELETE1(_param->_commit_priority                        ,_param->_nb_ooo_engine);
+        DELETE1(_param->_nb_re_order_buffer_bank                ,_param->_nb_ooo_engine);
+        DELETE1(_param->_size_re_order_buffer                   ,_param->_nb_ooo_engine);
+        DELETE1(_param->_nb_execute_loop_select                 ,_param->_nb_ooo_engine);
+        DELETE1(_param->_nb_rename_unit_select                  ,_param->_nb_ooo_engine);
+        DELETE1(_param->_nb_inst_branch_complete                ,_param->_nb_ooo_engine);
+        DELETE1(_param->_nb_inst_commit                         ,_param->_nb_ooo_engine);
+        DELETE1(_param->_nb_inst_reexecute                      ,_param->_nb_ooo_engine);
+        DELETE1(_param->_nb_inst_issue                          ,_param->_nb_ooo_engine);
+        DELETE1(_param->_nb_rename_unit                         ,_param->_nb_ooo_engine); 
+        DELETE2(_param->_dir_pht_size_address_share             ,_param->_nb_front_end,3);
+        DELETE2(_param->_dir_pht_nb_counter                     ,_param->_nb_front_end,3);
+        DELETE2(_param->_dir_pht_size_counter                   ,_param->_nb_front_end,3);
+        DELETE2(_param->_dir_have_pht                           ,_param->_nb_front_end,3);
+        DELETE2(_param->_dir_bht_nb_shifter                     ,_param->_nb_front_end,3);
+        DELETE2(_param->_dir_bht_size_shifter                   ,_param->_nb_front_end,3);
+        DELETE2(_param->_dir_have_bht                           ,_param->_nb_front_end,3);
+        DELETE1(_param->_dir_predictor_scheme                   ,_param->_nb_front_end);
+        DELETE1(_param->_btb_victim_scheme                      ,_param->_nb_front_end);
+        DELETE1(_param->_btb_size_counter                       ,_param->_nb_front_end);
+        DELETE1(_param->_btb_associativity                      ,_param->_nb_front_end);
+        DELETE1(_param->_btb_size_queue                         ,_param->_nb_front_end);
+        DELETE1(_param->_nb_inst_branch_update                  ,_param->_nb_front_end);
+        DELETE1(_param->_nb_inst_branch_decod                   ,_param->_nb_front_end);
+        DELETE1(_param->_nb_inst_branch_predict                 ,_param->_nb_front_end);
+        DELETE1(_param->_nb_decod_unit                          ,_param->_nb_front_end);
+        DELETE1(_param->_nb_context                             ,_param->_nb_front_end);
+        DELETE3(_param->_timing                                 ,_param->_nb_functionnal_unit,MAX_TYPE,MAX_OPERATION);
+        DELETE1(_param->_nb_inst_functionnal_unit               ,_param->_nb_functionnal_unit);
+        DELETE1(_param->_speculative_load                       ,_param->_nb_load_store_unit);
+        DELETE1(_param->_nb_inst_memory                         ,_param->_nb_load_store_unit);
+        DELETE1(_param->_nb_cache_port                          ,_param->_nb_load_store_unit);
+        DELETE1(_param->_nb_bypass_memory                       ,_param->_nb_load_store_unit);
+        DELETE1(_param->_nb_port_check                          ,_param->_nb_load_store_unit);
+        DELETE1(_param->_size_speculative_access_queue          ,_param->_nb_load_store_unit);
+        DELETE1(_param->_size_load_queue                        ,_param->_nb_load_store_unit);
+        DELETE1(_param->_size_store_queue                       ,_param->_nb_load_store_unit);
+        DELETE1(_param->_nb_bypass_write                        ,_param->_nb_write_bloc);
+        DELETE1(_param->_size_execute_queue                     ,_param->_nb_write_bloc);
+        DELETE1(_param->_size_write_queue                       ,_param->_nb_write_bloc);
+        DELETE1(_param->_nb_inst_retire_reservation_station     ,_param->_nb_read_bloc);
+        DELETE1(_param->_size_reservation_station               ,_param->_nb_read_bloc);
+        DELETE1(_param->_size_read_queue                        ,_param->_nb_read_bloc);
+        DELETE1(_param->_size_read_counter                      ,_param->_nb_rename_bloc);
+        DELETE1(_param->_nb_rename_unit_bank                    ,_param->_nb_rename_bloc);
+        DELETE1(_param->_nb_reg_free                            ,_param->_nb_rename_bloc);
+        DELETE1(_param->_nb_special_register                    ,_param->_nb_rename_bloc);
+        DELETE1(_param->_nb_general_register                    ,_param->_nb_rename_bloc);
+        DELETE1(_param->_rename_select_nb_front_end_select      ,_param->_nb_rename_bloc);
+        DELETE1(_param->_rename_select_load_balancing           ,_param->_nb_rename_bloc);
+        DELETE1(_param->_rename_select_priority                 ,_param->_nb_rename_bloc);
+        DELETE1(_param->_nb_inst_retire                         ,_param->_nb_rename_bloc);
+        DELETE1(_param->_nb_inst_insert                         ,_param->_nb_rename_bloc);
+        DELETE1(_param->_context_select_load_balancing          ,_param->_nb_decod_bloc);
+        DELETE1(_param->_context_select_priority                ,_param->_nb_decod_bloc);
+        DELETE1(_param->_nb_context_select                      ,_param->_nb_decod_bloc);
+        DELETE1(_param->_nb_inst_decod                          ,_param->_nb_decod_bloc);
+        DELETE1(_param->_size_decod_queue                       ,_param->_nb_decod_bloc);
+        DELETE1(_param->_upt_size_queue                         ,_param->_nb_thread);
+        DELETE1(_param->_ras_size_queue                         ,_param->_nb_thread);
+        DELETE2(_param->_implement_group                        ,_param->_nb_thread,NB_GROUP);
+        DELETE1(_param->_nb_inst_fetch                          ,_param->_nb_thread);
+        DELETE1(_param->_size_ifetch_queue                      ,_param->_nb_thread);
+       
+        delete _param;
+      }
+    log_end(Configuration,FUNCTION);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_fromFile.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_fromFile.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Configuration/src/Instance_fromFile.cpp	(revision 88)
@@ -0,0 +1,58 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Configuration/include/Instance.h"
+#include "Common/include/FromString.h"
+#include <fstream>
+
+namespace morpheo {
+namespace behavioural {
+namespace configuration {
+
+  using namespace XMLUtils;
+
+#undef  FUNCTION
+#define FUNCTION "Instance::fromFile"
+  void Instance::fromFile (std::string filename)
+  {
+    log_begin(Configuration,FUNCTION);
+
+    msg_printf(INFORMATION,_("Read file \"%s\"."),filename.c_str());
+
+    std::ifstream file (filename.c_str());
+
+    // Test the file open
+    if (!file)
+      throw ERRORMORPHEO(FUNCTION,toString(_("Error opening \"%s\" file.\n"),filename.c_str()));
+
+    // 1) FILL _array
+    XML_t * _xml = new FileXMLLight<char,ClassicReferenceCounter>(file);
+
+    // Test root node : Root name, must not a singleton, have none attribute
+    testNodeName   (_xml,"core");
+    testSingleton  (_xml,false);
+
+    attributes_t attributes = _xml->getAttributes();
+    _name = getAttribute(_xml,attributes,"name" );
+
+    fromXMLLight (_xml,
+                  "",
+                  _list_parameters,
+                  _list_links,
+                  _list_components);
+    
+    delete _xml;
+    
+    // 2) TEST/CREATE Parameters
+    fromInternalStructure();
+    
+    log_end(Configuration,FUNCTION);
+  };
+
+}; // end namespace configuration
+}; // end namespace behavioural
+}; // end namespace morpheo              
